var url = "http://picasaweb.google.com/picasateam/VegasWeekend";
var sizeIndex = 1;
var sizes = [[144, 96, "Small"], [288, 192, "Medium"], [400, 267, "Large"]];
var rssUrl = null;
//var rssUrl = "http://picasaweb.google.com/data/feed/api/user/piet.jonas/albumid/5104616209787635377?kind=photo&alt=rss&authkey=PcnY1fxpP5c";

function setup() {
  if (window.widget) {
    widgetSetup();
    readPrefs();
    widget.onremove = clearPrefs;
    widget.onshow = onshow;
    widget.onhide = onhide;
    if (!widget.context) {
      document.getElementById("Widgetop").style.display = "block";
    }
  }
}

function readPrefs() {
  if (window.widget) {
    var value = widget.preferenceForKey(widget.identifier + "-url");
    if (value) {
      url = value;
    }
    document.getElementById("UrlInput").value = url;  
    
    var value = widget.preferenceForKey(widget.identifier + "-size");
      alert(value);
    if (value != null) {
      sizeIndex = parseInt(value);
    }
    document.getElementById("Size").selectedIndex = sizeIndex;  

    var value = widget.preferenceForKey(widget.identifier + "-color");
    if (value != null) {
      document.getElementById("Color").value = value;  
    }

    updateAddress();
  }
}

function clearPrefs() {
  widget.setPreferenceForKey(null, widget.identifier + "-url");
  widget.setPreferenceForKey(null, widget.identifier + "-size");
  widget.setPreferenceForKey(null, widget.identifier + "-color");
}

function onshow() {
}

function onhide() {
}

function openUrl() {
  widget.openURL(url);
}

function updateAddress() {
  var sizeIndex = document.getElementById("Size").selectedIndex;
  var width = sizes[sizeIndex][0] + 34;
  var height = sizes[sizeIndex][1] + 58;
  alert(width + " x " + height);
  window.resizeTo(width, height);
  document.getElementById("Background").style.backgroundImage = "url(shadow" 
    + sizes[sizeIndex][2] + ".png)";
  document.getElementById("SlideBorder").style.backgroundImage = "url(border" 
    + sizes[sizeIndex][2] + ".png)";
  var request = new XMLHttpRequest();
  request.onload = function() {
    var color = document.getElementById("Color").value;
    document.getElementById("SlideBackground").style.backgroundColor = "#" + color;
    document.getElementById("SlideShow").style.backgroundColor = "#" + color;
    if (request.status = 200) {
      var text = request.responseText.toLowerCase();
      var index = text.indexOf("http://picasaweb.google.com/data/feed");
      if (index > 0) {
        var lastIndex = text.indexOf("\"", index);
        if (lastIndex < 0) {
          lastIndex = text.indexOf("\"", index);
        }
        else if (lastIndex < 0) {
          lastIndex = text.indexOf("'", index);
        }
        else if (lastIndex < 0) {
          lastIndex = text.indexOf(" ", index);
        }
        if (lastIndex > 0) {
          rssUrl = text.substring(index, lastIndex);
          rssUrl = rssUrl.replace(/\&amp\;/g, "&");
          rssUrl = rssUrl.replace(/base/, "api");
        }
      }
    }
    alert(rssUrl);
    var flashVars = "host=picasaweb.google.com";
    flashVars += "&RGB=0x" + color;
    flashVars += "&feed=" + encodeURIComponent(rssUrl);
    //show.setAttribute("flashvars", flashVars);
    document.getElementById("SlideContainer").innerHTML = 
      '<embed id="SlideShow" type="application/x-shockwave-flash" src="http://picasaweb.google.com/s/c/bin/slideshow.swf" '
      + 'width="' + sizes[sizeIndex][0] +'" height="' + sizes[sizeIndex][1]
      + '" flashvars="' + flashVars 
      + '" pluginspage="http://www.macromedia.com/go/getflashplayer" palette="background"></embed>'; 
    var show = document.embeds[0];
    show.width = sizes[sizeIndex][0];
    show.height = sizes[sizeIndex][1];
  }
  request.open("GET", url);
  request.send(null);
}

function setSize(size) {
  widget.setPreferenceForKey(size, widget.identifier + "-size");
  document.getElementById("Size").selectedIndex = size;
  updateAddress();
}

function showSizer() {
  document.getElementById("SmallSize").style.display = "block";  
  document.getElementById("MediumSize").style.display = "block";  
  document.getElementById("LargeSize").style.display = "block";  
}

function hideSizer() {
  document.getElementById("SmallSize").style.display = "none";  
  document.getElementById("MediumSize").style.display = "none";  
  document.getElementById("LargeSize").style.display = "none";  
}

function showHelp() {
  document.getElementById("Help").style.display = "block";
}

function closeHelp() {
  document.getElementById("Help").style.display = "none";  
}

function openExample(example) {
  closeHelp();
  document.getElementById("UrlInput").value = "http://picasaweb.google.com/" + example;
  hideBack();
}

function widgetSetup() {
  if (window.widget) {
  	var gDoneButton = new AppleGlassButton(document.getElementById("DoneButton"), 
  	                                      "Done", hideBack); 
  	var gHelpButton = new AppleGlassButton(document.getElementById("HelpButton"), 
  	                                      "Help", showHelp); 
	  var gInfoButton = new AppleInfoButton(document.getElementById("InfoButton"), 
	                                        document.getElementById("front"), 
	                                        "white", "white", showBack);    
  }
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if(window.widget)
        widget.prepareForTransition("ToBack");
 
    front.style.display="none";
    window.resizeTo(220, 290);
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    back.style.display="none";
    window.resizeTo(320, 280);
    url = document.getElementById("UrlInput").value;
    updateAddress();
    //document.getElementById("Address").innerHTML = url;
    widget.setPreferenceForKey(url, widget.identifier + "-url");
    sizeIndex = parseInt(document.getElementById("Size").value);
    widget.setPreferenceForKey(sizeIndex, widget.identifier + "-size");
    widget.setPreferenceForKey(document.getElementById("Color").value, widget.identifier + "-color");
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

if (top.myBrowser.needsXMLHttpRequestVariable) {var XMLHttpRequest;}